% Figure1_7.m
% It requires the following functions:
% heun2.m
% eulerE.m
% spTVT2.m
% spTVT2m.m
% fKepler.m
% fKeplerT.m
% fKeplerV.m
% fKeplerVm.m
% phiKepler
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial and final time, and  Time step
global h
t0=0;  tf=200; 
for k=1:2
t=[];
erEnE1=[]; erPosE1=[]; costE1=[];
erEnH2=[]; erPosH2=[]; costH2=[];
erEnSVT=[]; erPosSVT=[]; costSVT=[];
erEnSVTm=[]; erPosSVTm=[]; costSVTm=[];
% Initial Conditions 
e=0.2*(2-k);   
x0 = [1-e ; 0; 0; sqrt((1+e)/(1-e))];
q0=[x0(1); x0(2)];  p0=[x0(3); x0(4)]; 
% Energy at initial conditions
H0=((x0(3))^2+(x0(4))^2)/2-1/(sqrt((x0(1))^2+(x0(2))^2));

for i=1:10
   t=[];   x=[];  x1=[];   x2=[];  q2=[];  p2=[];  q2m=[];  p2m=[];
   N=20*2^i;  h = (tf-t0)/N;
   [t x1]=eulerE(@fKepler,t0,tf,x0,N);
   [t x2]=heun2(@fKepler,t0,tf,x0,N);
   [t q2 p2]=spTVT2(@fKeplerT,@fKeplerV,t0,tf,q0,p0,N);
   [t q2m p2m]=spTVT2m(@fKeplerT,@fKeplerVm,t0,tf,q0,p0,N);

   x = x0'; th=t0; qin=q0; pin=p0;
   for i=1:N;
      th=th+h;
      [q p]=phiKepler(qin,pin,h);
      x=[x; q p];
      qin=q; pin=p;
   end

   eP1=max(x-x1);
   eP2=max(x-x2);
   eSVT=max(max(x(:,1:2)-q2,x(:,3:4)-p2));
   eSVTm=max(max(x(:,1:2)-q2m,x(:,3:4)-p2m));

   errorE1 = ((x1(:,3)).^2+(x1(:,4)).^2)./2-1./(sqrt((x1(:,1)).^2+(x1(:,2)).^2)) - H0;
   errorH2 = ((x2(:,3)).^2+(x2(:,4)).^2)./2-1./(sqrt((x2(:,1)).^2+(x2(:,2)).^2)) - H0;
   errorSVT = ((p2(:,1)).^2+(p2(:,2)).^2)./2-1./(sqrt((q2(:,1)).^2+(q2(:,2)).^2)) - H0;
   errorSVTm = ((p2m(:,1)).^2+(p2m(:,2)).^2)./2-...
       1./(sqrt((q2m(:,1)).^2+(q2m(:,2)).^2)) - H0;

    erPosE1=[erPosE1; max(eP1)]; erEnE1=[erEnE1; max(abs(errorE1))]; costE1=[costE1; N];
    erPosH2=[erPosH2; max(eP2)]; erEnH2=[erEnH2; max(abs(errorH2))]; costH2=[costH2; 2*N];
    erPosSVT=[erPosSVT; max(eSVT)]; erEnSVT=[erEnSVT; max(abs(errorSVT))]; costSVT=[costSVT; N];
    erPosSVTm=[erPosSVTm; max(eSVTm)]; erEnSVTm=[erEnSVTm; max(abs(errorSVTm))]; costSVTm=[costSVTm; N];
end

figure(2)
 subplot(2,2,2*k-1)
  hold on
  plot(log10(costE1),log10(erEnE1(:)),'-k','LineWidth',1.5,'Color',[0 0 0]+0.8)
  plot(log10(costH2),log10(erEnH2(:)),'-ok','LineWidth',1.5)
  plot(log10(costSVT),log10(erEnSVT(:)),'-k','LineWidth',1.5)
  plot(log10(costSVTm),log10(erEnSVTm(:)),'-*k','LineWidth',1.5)
  axis([1.5 4.5 -4.5*k 1]) 
  xlabel('{\fontsize{14} log_{10}(N. eval.) }')   
  ylabel('{\fontsize{14} log_{10}(Err. En.)}')   
  box

 subplot(2,2,2*k)
  hold on
  plot(log10(costE1),log10(erPosE1(:)),'-k','LineWidth',1.5,'Color',[0 0 0]+0.8)
  plot(log10(costH2),log10(erPosH2(:)),'-ok','LineWidth',1.5)
  plot(log10(costSVT),log10(erPosSVT(:)),'-k','LineWidth',1.5)
  plot(log10(costSVTm),log10(erPosSVTm(:)),'-*k','LineWidth',1.5)
  axis([1.5 4.5 -2.5*k 1.5]) 
  xlabel('{\fontsize{14} log_{10}(N. eval.) }')   
  ylabel('{\fontsize{14} log_{10}(Err. Pos.)}')   
  box
end

